#include "protheus.ch"
#include "topconn.ch"
#include "rwmake.ch"
#INCLUDE "APWIZARD.CH"

User function Rfatv01()

//  Declarao de variveis utilizadas no programa
private cString, aRotina, aCores, cCadastro
private cPerg := 'Rfatv01'
private cFiltro := " "
private aCores  := {}
Private cCadastro := "PAINEL DE VENDAS"
Private bFiltraBrw:= {|| NIL}
//Private aIndex := {} 

// Valida perguntas no SX1, caso no exista cria as perguntas
//ValidaPerguntas()

// Pergunta no SX1
if !pergunte(cPerg,.T.)
	return
end

cString := 'SC6'
aIndex := {}
//Private bFiltraBrw:= { || FilBrowse("SC6",@aIndex,@cFiltro) } 


// O bloco abaixo define e executa o filtro de acordo com a tela de parametros

// Preparacao para validacao da data1 do cliente ou data de entrega
_mParFAT := GETMV("MV_YUSRFAT")
_mCodusr := __cUserID

// Verifica se considera faturados

If MV_PAR10 == 2  // nao considera
	// Abaixo: Se usuario nao for do Faturamento usa data do cliente (C6_SUGENTR), caso contrario C6_ENTREGA
	If !_mCodusr$_mParFAT
		cFiltro := "C6_QTDVEN > C6_QTDENT .And. C6_SUGENTR >= ctod('"+DTOC(MV_PAR01)+"') .And. C6_SUGENTR <= ctod('"+dtoc(MV_PAR02)+"') "//Expressao do Filtro
	Else
		cFiltro := "C6_QTDVEN > C6_QTDENT .And. C6_ENTREG >= ctod('"+DTOC(MV_PAR01)+"') .And. C6_ENTREG <= ctod('"+dtoc(MV_PAR02)+"') "//Expressao do Filtro
	Endif
Else     // Considera faturados
	If !_mCodusr$_mParFAT
		cFiltro := "C6_SUGENTR >= ctod('"+DTOC(MV_PAR01)+"') .And. C6_SUGENTR <= ctod('"+dtoc(MV_PAR02)+"') "//Expressao do Filtro
	Else
		cFiltro := "C6_ENTREG >= ctod('"+DTOC(MV_PAR01)+"') .And. C6_ENTREG <= ctod('"+dtoc(MV_PAR02)+"') "//Expressao do Filtro
	Endif
	
Endif

cFiltro += ".And. C6_FILIAL == '"+CFILANT+"'"
cFiltro += ".And. C6_CLI >= '"+MV_PAR03+"' .And. C6_CLI <= '"+MV_PAR04+"' "
cFiltro += ".And. C6_LOJA >= '"+MV_PAR05+"' .And. C6_LOJA <= '"+MV_PAR06+"' "
cFiltro += ".And. C6_YOBRA >= '"+MV_PAR07+"' .And. C6_YOBRA <= '"+MV_PAR08+"' "

// Implementado Filtro para desconsiderar residuos - by Wlad 07/09/2013
If MV_PAR09 == 2
	cFiltro += " .And. trim(C6_BLQ) <> 'R' "
Endif

If mv_par10 == 2  // Se nao considerar faturados                                                         
	Private aCampos := {{"Nome Cliente  " 	,"Posicione('SA1',1,xFilial('SA1')+C6_CLI+C6_LOJA,'A1_NOME')",""},;
	{"Obra      "     	,"C6_YDESCOB",""},;
	{"Pedido"        	,"C6_NUM"	  ,""},;
	{"Item"        		,"C6_ITEM"	  ,""},;
	{"Produto        "  ,"C6_DESCRI" ,""},;
	{"Dt Na Obra"  		,"DTOC(C6_SUGENTR)" ,""},;
	{"Dt Expedio"  	,"DTOC(C6_ENTREG)" ,""},;
	{"NFiscal"  		,"C6_NOTA" ,""},;
	{"Vendida"   		,"Transform(C6_QTDVEN,'@E 99,999.99')" ,""},;
	{"Entregue"   		,"Transform(C6_QTDENT,'@E 99,999.99')" ,""},;
	{"Liberada" 		,"Transform(C6_QTDLIB,'@E 99,999.99')" ,""},;
	{"Saldo PV"  		,"Transform(C6_QTDVEN-C6_QTDENT-C6_QTDLIB-C6_QTDEMP,'@E 99,999.99')",""},;
	{"Veiculo"  		,"C6_YVEICUL" ,""},;
	{"Placa"  			,"C6_YPLACA" ,""},;
	{"Motorista" 		,"C6_YCODMOT" ,""},;
	{"Nome Motorista"  	,"C6_YNOMMOT" ,""}}
Else
	Private aCampos := {{"Nome Cliente  " 	,"Posicione('SA1',1,xFilial('SA1')+C6_CLI+C6_LOJA,'A1_NOME')",""},;
	{"Obra      "     	,"C6_YDESCOB",""},;
	{"Pedido"        	,"C6_NUM"	  ,""},;
	{"Produto        "  ,"C6_DESCRI" ,""},;
	{"Item"  			,"C6_ITEM" ,""},;
	{"No Nota"  		,"C6_NOTA" ,""},;
	{"Dt Expedio"  	,"DTOC(C6_ENTREG)" ,""},;
	{"Veiculo"  		,"C6_YVEICUL" ,""},;
	{"Placa"  			,"C6_YPLACA" ,""},;
	{"Motorista" 		,"C6_YCODMOT" ,""},;
	{"Nome Motorista"  	,"C6_YNOMMOT" ,""},;
	{"Vendida"   		,"Transform(C6_QTDVEN,'@E 99,999.99')" ,""},;
	{"Entregue"   		,"Transform(C6_QTDENT,'@E 99,999.99')" ,""},;
	{"Liberada" 		,"Transform(C6_QTDLIB,'@E 99,999.99')" ,""},;
	{"Saldo PV"  		,"Transform(C6_QTDVEN-C6_QTDENT-C6_QTDLIB-C6_QTDEMP,'@E 99,999.99')",""}}
	
//	{"PRODUTO"    ,"C6_PRODUTO",PesqPict("SC6","C6_PRODUTO") } ,;
	
Endif
 


// Define as Opes e os programas que sero chamados pelas mesmas
Private aRotina := {{"PESQUISAR","PesqBrw",0,1},;
{"LEGENDA   ","U_Legenda()",0,5 },;
{"COMERCIAL ","U_mAtuCom()",0,4},;
{"LOGISTICA ","U_mAtuLog()",0,3},;
{"FATURAMENT","U_mAtuFat()",0,2 },;
{"LIBERAR PEDIDO","MATA440()",0,6 },;
{"LIBERAR ESTOQUE","MATA456()",0,6 },;
{"DOC. SAIDA","MATA460A()",0,6 },;
{"TRANSMITIR NF","SPEDNFE()",0,6 }}

// Define os campos do mBrowse

// Define os Semaforos
//private aCores  := {}

// Define os Semaforos
private aCores  := {;
{"C6_QTDVEN-C6_QTDENT < 15 .AND.  C6_QTDENT > 0","BR_MARROM"},;
{"C6_QTDVEN-C6_QTDENT = 0 .AND.  C6_QTDENT > 0","BR_AZUL"},;
{"C6_YSTATUS == 'F'","ENABLE" },; 	// VERDE	- Liberado para Faturamento
{"C6_YSTATUS == 'C' .or. EMPTY(C6_YSTATUS)","DISABLE"},; 	// VERMELHO - Aguardando liberacao do comercial
{"C6_YSTATUS == 'L'","BR_LARANJA"}} // LARANJA Liberado para a logistica

// Define as legendas
private aLegenda:= {{'BR_VERMELHO','Pedido Comercial'},;
{'BR_LARANJA','Pedido Logistica'	},;
{'BR_VERDE' ,'Pedido Faturamento'},;
{'BR_AZUL' ,'Pedido Faturado'},;
{'BR_MARROM' ,'Resduo de Pedido'}}

// Executa filtro de acordo com os parametros informados

//FilBrowseEval(bFiltraBrw)


bFiltraBrw := { || FilBrowse( "SC6" , @aIndex , @cFiltro ) } //Determina a Expressao do Filtro
Eval( bFiltraBrw )    //Efetiva o Filtro antes da Chamada a mBrowse

mBrowse( 6,1,22,75,"SC6",aCampos,,,,,aCores)   
EndFilBrw("SC6", @aIndex) //Finaliza o Filtro
Return Nil

// Tela de Atualizao pelo setor Comercial

// Rotina para Utilizao do setor comercial - Liberao para Logstica

User function mAtuCom()

// valida se usuario tem acesso a rotina
_mParCOM := GETMV("MV_YUSRCOM")
_mCodusr := __cUserID

If !_mCodusr$_mParCOM
	MSGBOX("Ateno! Usurio No autorizado.","Liberao do Pedido","ALERT")
	Return(Nil)
Endif


// Critica se ja foi liberado da Logstica para o Comercial
If SC6->C6_YSTATUS == 'F'
	MSGBOX("Ateno! Este pedido esta indiposnvel para o Comercial, contate o setor de LOGSTICA","Pedido Indisponvel","ALERT")
	Return(Nil)
ENdif

// Posiciona SC5
dbSelectArea("SC5")
dbSetOrder(1)
dbSeek(xFilial()+SC6->C6_NUM)

dbSelectArea("SC6")


_mData   := C6_SUGENTR   			// data de entrega
_mQtdLib := 0                       // QTD Liberada
_mTpfrete	:= SC5->C5_TPFRETE		// Tipo de frete
aDescTPfrt := {}					// Array para conter as opes de tipo de frete
cBlqCred  	:= ""					// Variavel que retorna o bloqueio de crdito
_mCredito := .t.					// Varivel lgica para retornar se o cliente possui saldo de crdito
_myVfrete := SC5->C5_YVFRETE		// Valor do Frete
_myMenlog := SC5->C5_YMENLOG		// Mensagem para Logistica

// Itens do COMBO Tipo Frete
AADD (aDescTPfrt, "1 - CIF")
AADD (aDescTPfrt, "2 - FOB")
//AADD (aDescTPfrt, "3 - FOB PROPRIO")


//Colocar Validao para Dados da logistica. Se preenchido nao pode mais alterar

@ 100,075 To 370,645 Dialog oDialogo Title OemToAnsi("Liberao Comercial de Pedidos - Pedido:"+SC6->C6_NUM)
@ 010,015 Say OemToAnsi("Data no Cliente")  		Size 045,20
@ 010,150 Say OemToAnsi("Valor do Frete")  			Size 045,20
@ 030,015 Say OemToAnsi("Quantidade Liberada")   	Size 045,20
@ 030,150 Say OemToAnsi("Observ de Frete") 			Size 060,20
@ 050,015 say OemToAnsi("Tipo Frete : ")
//@ 010,150 line 050,0200
//@ 050,015 Say OemToAnsi("Data de envio")      	Size 045,20

@ 010,065 Get _mData		                  		Size 050,50
@ 010,200 Get _myVfrete	PICTURE "@E 99,999.99"		Size 050,50
@ 030,065 Get _mQtdLib  PICTURE "@E 99,999.99"		Size 050,50
@ 040,150 Get _myMenlog	Picture "@!"        		Size 100,50

@ 050,065 MSCOMBOBOX oCbx1 VAR _mTpfrete ITEMS aDescTPfrt SIZE 60, 47 OF oDialogo PIXEL

//@ 050,065 Get _Data3                          	Size 050,50
@ 070,20  BmpButton Type 01 Action _AtuPedCom()
@ 070,90  BmpButton Type 02 Action Close(oDialogo)

@ 100,015 Say OemToAnsi("Data da Liberao: " + dtoc(dDatabase))  		Size 150,20
@ 110,015 Say OemToAnsi("Hora da Liberao: " + Time())  					Size 150,20
Activate Dialog oDialogo CENTERED

Return

// Tela de Atualizao pelo setor de Logistica

// Rotina para Utilizao do setor Logistica

User function mAtuLog()

// valida se usuario tem acesso a rotina
_mParLOG := GETMV("MV_YUSRLOG")
_mCodusr := __cUserID

If !_mCodusr$_mParLOG
	MSGBOX("Ateno! Usurio No autorizado.","Liberao do Pedido","ALERT")
	Return(Nil)
Endif

If SC6->C6_YSTATUS == 'C'
	MSGBOX("Ateno! Este pedido esta indiposnvel para o Setor de Logistica.","Pedido Indisponvel","ALERT")
	Return(Nil)
ENdif


// Posiciona no SC5
dbSelectArea("SC5")
dbSetOrder(1)
dbSeek( xFilial("SC5")+SC6->C6_NUM )

_mMotoris  	:= SC6->C6_YCODMOT		// Codigo do Motorista
//_mNomMot	:= IIF(empty(SC5->C5_MENNOT3),"MOTORISTA: ",SC5->C5_MENNOT3)  // Mensagem3 - motorista
_mNomMot	:= posicione("DA4",1,xFilial("DA4")+SC6->C6_YCODMOT,"DA4_NOME")      // Nome Motorista
_mVeiculo 	:= SC6->C6_YVEICUL		// Veiculo
_mPlaca		:= SC6->C6_YPLACA   	// Placa
_mVfrete	:= SC5->C5_YVFRETE      // Valor do Frete
_mUFPlaca	:= posicione("DA3",1,xFilial("DA3")+SC6->C6_YVEICUL,"DA3_ESTPLA") //SC6->C6_UFPLACA		// UF da placa
_mRNTC		:= SPACE(10) 			// RNTC
_mTPV		:= SPACE(2)				// Tipo veiculo
_mQtdLib	:= SC6->C6_QTDLIB		// Quantidade Liberada
_mTransp	:= SC5->C5_TRANSP		// Transportadora
_mTpfrete	:= SC5->C5_TPFRETE		// Tipo de frete
_mNomtrans  := Space(15)			// Nome transportadora
_mData   	:= SC6->C6_ENTREG   			// data de entrega
//_myDist		:= Posicione("DUL",2,xFilial("DUL")+SC6->C6_CLI+SC6->C6_LOJA+SC6->C6_YOBRA,"DUL_YDIST")
// Alterado para retornar a distancia do SC5
_myDist		:= SC5->C5_YKM
_myObra     := Posicione("DUL",2,xFilial("DUL")+SC6->C6_CLI+SC6->C6_LOJA+SC6->C6_YOBRA,"DUL_MUN")
_mEst       := Posicione("DUL",2,xFilial("DUL")+SC6->C6_CLI+SC6->C6_LOJA+SC6->C6_YOBRA,"DUL_EST")
_yMenLog    := SC5->C5_YMENLOG		// Mensagem especifica para logistica
_yDtlcom	:= SC6->C6_YDTLCOM		// Data Liberacao comercial
_yHrlcom	:= SC6->C6_YHRLCOM		// Hora Liberacao comercial
// Campo da observacao
_yC6obs     := SC6->C6_YC6OBS   // Observao quando houver alterao do Pedido


@ 100,075 To 470,745 Dialog oDialogo1 Title OemToAnsi("Complemento de Pedidos - Logstica - Pedido : "+SC6->C6_NUM)

@ 010,015 Say OemToAnsi("Data no Cliente: "+DTOC(SC6->C6_SUGENTR))  	 //	Size 045,20
@ 010,180 Say OemToAnsi("Data Expedio : ")  	  						 //	Size 045,20
@ 030,015 Say OemToAnsi("Quantidade Liberada")   						Size 045,20
@ 030,180 say OemToAnsi("Tipo Frete : "+IIF(_mTpfrete == "C","CIF","FOB"))
@ 030,250 say OemToAnsi("Vl Frete : " +Transform(_mVfrete,"@E99,999.99"))
@ 050,015 Say OemToAnsi("Motorista")  									Size 045,20
@ 070,015 Say OemToAnsi("Veiculo  ")   									Size 045,20

// aqui ser colocado o campo para Obsercao, em caso de altero do pedido de vendas..
@ 090,015 say OemToAnsi("Transportadora ")								Size 045,20

If SC6->C6_YALTERA == .T.
	@ 100,130 say OemToAnsi("Motivo Alterao: ")
	@ 100,170 Get _yC6obs                             						Size 130,50
endif

//-------------------------

@ 110,015 say OemToAnsi("Distncia: " +Transform(_myDist,"@E99,999.99"))
@ 120,015 say OemToAnsi("Obra: " + _myObra)
@ 120,180 say OemToAnsi("UF: " + _mEst)
@ 150,180 say OemToAnsi("Obs Frete : " + _yMenLog)

@ 010,220 Get _mData		                  							Size 050,50
@ 030,065 Get _mQtdLib  Valid U__mVldLib() PICTURE "@E 99,999.99"		Size 050,50
@ 050,065 Get _mMotoris	F3 "DA4Z2"          							Size 050,50
@ 050,130 Get _mNomMot				   									Size 050,100
@ 070,065 Get _mVeiculo F3 "DA3Z1"										Size 050,50
@ 070,130 Get _mPlaca													Size 050,50
@ 070,200 Get _mUFPlaca													Size 020,50
@ 070,240 Get _mRNTC  													Size 050,50
@ 070,270 Get _mTPV  													Size 020,50
@ 090,065 Get _mTransp F3 "SA4"	Valid u__Nometran()						Size 050,50
//@ 090,095 Say OemToAnsi(_mNomtrans)      								Size 050,50


//@ 050,065 Get _Data3                          	Size 050,50
@ 130,20  BmpButton Type 01 Action _AtuPedLog()
@ 130,90  BmpButton Type 02 Action Close(oDialogo1)

@ 150,015 Say OemToAnsi("Liberao Comercial " + dtoc(_yDtlcom)+" - "+_yHrlcom)  		Size 150,20
@ 160,015 Say OemToAnsi("Liberao Logistica " + dtoc(dDatabase)+" - "+Time())  		Size 150,20


Activate Dialog oDialogo1 CENTERED

Return


// Tela de Atualizao pelo setor de Faturamento

User function mAtuFat()

// valida se usuario tem acesso a rotina
_mParFAT := GETMV("MV_YUSRFAT")
_mCodusr := __cUserID

If !_mCodusr$_mParFAT
	MSGBOX("Ateno! Usurio No autorizado.","Liberao do Pedido","ALERT")
	Return(Nil)
Endif

If SC6->C6_YSTATUS == 'C' .or. SC6->C6_YSTATUS == 'L'
	MSGBOX("Ateno! Este pedido esta indiposnvel para o faturamento.","Pedido Indisponvel","ALERT")
	Return(Nil)
ENdif


// Posiciona no SC5
dbSelectArea("SC5")
dbSetOrder(1)
dbSeek( xFilial("SC5")+SC6->C6_NUM )

// Inicializa campos a partir da tabela
private oCbx1   // Objeto da combobox 1 - Tipo frete
private oCbx2   // Objeto da combobox 2 - Especie

Private aDescTPfrt := {}  // Arrray para Tipo de Frete
Private aDescEspec := {}  // Array para Especie de carga

// Inicializa Variveis pra calculo de impostos
_nAliqIcm := 0
_nAliqSol := 0
_nValIcm  := 0
_nBaseIcm := 0
_nBaseSol := 0
_nValMerc := 0
_nValSol  := 0
_nValDesc := 0
_nPrVen   := 0

// Inicializa as variaveis a partir das variaveis de arquivo
_mMotoris  	:= SC5->C5_YCODMOT		// Codigo do Motorista
_mNomMot	:= posicione("DA4",1,xFilial("DA4")+SC6->C6_YCODMOT,"DA4_NOME")
_mTransp	:= SC5->C5_TRANSP
_mTpfrete	:= SC5->C5_TPFRETE
_mPesoL		:= SC5->C5_PESOL
_mPbruto	:= SC5->C5_PBRUTO
_mVolume1	:= IIF(SC5->C5_VOLUME1 == 0,1,SC5->C5_VOLUME1)   // Preenche com 1 se estiver zerado
_mVfrete	:= SC5->C5_YVFRETE
_mEspeci1	:= SC5->C5_ESPECI1
_mTpCarga	:= SC5->C5_TPCARGA
_mVeiculo 	:= SC6->C6_YVEICULO    	// C5_VEICULO
_mPlaca		:= SC6->C6_YPLACA    	// C5_PLACA
_mUFPlaca	:= SC6->C6_YUFPLACA		// C5_UFPLACA
_yDtlcom	:= SC6->C6_YDTLCOM		// Data Liberacao comercial
_yHrlcom	:= SC6->C6_YHRLCOM		// Hora Liberacao comercial
_yDtllog	:= SC6->C6_YDTLLOG		// Data Liberacao Logistica
_yHrllog	:= SC6->C6_YHRLLOG		// Hora Liberacao Logistica

_mQTdlib	:= SC6->C6_QTDLIB
//Mensagens
_mMenssag1  := SC5->C5_MENNOT1
_mMenssag2  := SC5->C5_MENNOT2
_mMenssag3  := SC5->C5_MENNOT3
_mMenssag4  := SC5->C5_MENNOT4
_mMenssag5  := SC5->C5_MENNOT5
_mMenssag6  := SC5->C5_MENNOT6
_mMenssag7  := SC5->C5_MENNOT7

// Preenche Mensagem De pedido / recebedor na Obra     By wlad 26/08/13
//If empty(_mMenssag1)       -- desabilitado if, prob numerao ped_cli by Gledson
_mMenssag1  := "PEDIDO: "+SC6->C6_PEDCLI + " - RECEBEDOR NA OBRA :" + Posicione("DUL",2,xFilial("DUL")+SC6->C6_CLI+SC6->C6_LOJA+SC6->C6_YOBRA,"TRIM(DUL_YRECEB)" )
_mMenssag1  += +space(118-len(_mMenssag1))
//Endif

// Prenche Faturista
If empty(_mMenssag3)
	_mMenssag3  := "FATURISTA: " + substr(cUsuario,7,15) + space(90)
	_mMenssag3  += +space(118-len(_mMenssag3))
Endif


// Preenche Mensagem De frete se for CIF     By wlad 26/08/13
If empty(_mMenssag4)
	If _mTpfrete == "C"
		_mMenssag4  := "OBS: PRECO CIF FRETE INCLUSO NO VALOR DA MERCADORIA  "
		_mMenssag4  += +space(118-len(_mMenssag4))
	Endif
Endif

//Verifica se esta vazio, caso positivo, pega mensagem padro
If empty(_mMenssag5)
	//_mMenssag5  := "N. ONU 3257-CLASSE 9 CERTIFICAMOS QUE O PRODUTO ESTA  ADEQUADAMENTE ACONDICIONADO PARA SUPORTAR RISCOS DE CARREGAMENTO,"  -- Alterado em 04/04/2071 - Srgio Cardoso (No  mais necessrio a informao do cdigo ONU neste ponto. A partir de agora, o sistema se encarrega deste preenchimento)
	_mMenssag5  := "CLASSE 9 CERTIFICAMOS QUE O PRODUTO ESTA  ADEQUADAMENTE ACONDICIONADO PARA SUPORTAR RISCOS DE CARREGAMENTO,"
	_mMenssag5  += +space(118-len(_mMenssag5))
	//1234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678
	//         1         2         3         4         5         6         7         8         9         0         1
Endif
//Verifica se esta vazio, caso positivo, pega mensagem padro
If empty(_mMenssag6)
	_mMenssag6  := "DESCARREGAMENTO, TRANSBORDO E TRANSPORTE, CONFORME LEGISLACAO EM VIGOR."
	_mMenssag6  += +space(118-len(_mMenssag6))
	
Endif

If empty(_mMenssag7)//Verifica se esta vazio, caso positivo, pega mensagem padro
	_mMenssag7  := "ESPECIE: LIQUIDO"+space(102)
Endif

// Itens do COMBO Especie
AADD (aDescEspec  , "GRANEL,LIQUIDO")
AADD (aDescEspec  , "TAMBOR,LIQUIDO")

// Itens do COMBO Tipo Frete
//AADD (aDescTPfrt, "1 - CIF")
//AADD (aDescTPfrt, "2 - FOB")

@ 020,020 To 670,745 Dialog oDialogo2 Title OemToAnsi("Complemnento de Pedidos - Faturamento - Pedido :"+SC6->C6_NUM)
@ 010,015 Say OemToAnsi("Motorista: "+Trim(_mMotoris)+"-"+trim(_mNomMot))  			//Size 050,200
@ 010,155 Say OemToAnsi("QTD Liberada: "+Transform(_mQTdlib,"@E 9,999.99"))  			//Size 050,200
@ 030,015 Say OemToAnsi("Veiculo: "+_mVeiculo+' - '+_mPlaca)		//Size 050,200
@ 030,100 Say OemToAnsi("Produto: "+Trim(SC6->C6_PRODUTO)+"-"+trim(SC6->C6_DESCRI))  			//Size 050,200
@ 040,015 say OemToAnsi("Transportadora: "+Trim(Posicione("SA4",1,xFilial("SA4")+_mTransp,"A4_NOME")))
@ 040,180 say OemToAnsi("Tipo Frete : "+IIF(_mTpfrete == "C","CIF","FOB"))
@ 050,015 Say OemToAnsi("Valor Frete: "+Transform(_mVfrete,"@E 99,999.99"))

// Dados de Calculo do Pedido
@ 005,270 to 070,360
@ 010,280 say OemToAnsi("Valor da Mercadoria: " )
@ 020,280 say OemToAnsi("Valor Base ICMS    : " )
@ 030,280 say OemToAnsi("Valor ICMS         : " )
@ 040,280 say OemToAnsi("Valor da ICMS ST   : " )
@ 050,280 say OemToAnsi("Valor Total NF     : " )
@ 060,280 say OemToAnsi("Valor Unitario     : " )

@ 070,015 say OemToAnsi("Peso Liquido : ")    		//+Transform(_mPesoL,'@E 99,999.99'))
@ 070,105 say OemToAnsi("Peso Bruto : ")     		//+Transform(_mPBruto,'@E 99,999.99'))
@ 070,205 say OemToAnsi("Volume : " )				//+Transform(_mVolume1,'@E 99,999.99'))
@ 090,015 say OemToAnsi("Especie : ")				//+_mEspeci1)
//@ 090,015 say OemToAnsi("Tipo de Carga : "

@ 110,015 say OemToAnsi("Mens. NF 1 : ")
@ 130,015 say OemToAnsi("Mens. NF 2 : ")
@ 150,015 say OemToAnsi("Mens. NF 3 : ")
@ 170,015 say OemToAnsi("Mens. NF 4 : ")
@ 190,015 say OemToAnsi("Mens. NF 5 : ")
@ 210,015 say OemToAnsi("Mens. NF 6 : ")
@ 230,015 say OemToAnsi("Mens. NF 7 : ")

@ 070,050 Get _mPesoL    valid U__ValidPeso(_mPesoL) Picture "@E 99,999.99"
@ 070,135 Get _mPbruto   valid  					 Picture "@E 99,999.99"   //U__ValidPeso(_mPBruto)
@ 070,230 Get _mVolume1  Picture  "@E 99"

@ 090,050 MSCOMBOBOX oCbx2 VAR _mEspeci1 ITEMS aDescEspec SIZE 60, 47 OF oDialogo2 PIXEL

@ 110,050 Get _mMenssag1  Picture "@!" 				Size 250,050
@ 130,050 Get _mMenssag2  Picture "@!"				Size 250,050
@ 150,050 Get _mMenssag3  Picture "@!"				Size 250,050
@ 170,050 Get _mMenssag4  Picture "@!"				Size 250,050
@ 190,050 Get _mMenssag5  Picture "@!"	F3 "S4M"	Size 250,050
@ 210,050 Get _mMenssag6  Picture "@!"	F3 "S4M"	Size 250,050
@ 230,050 Get _mMenssag7  Picture "@!"				Size 250,050

@ 250,135 Say OemToAnsi("Liberao Comercial " + dtoc(_yDtlcom)+" - "+_yHrlcom)  		Size 150,20
@ 260,135 Say OemToAnsi("Liberao Logistica " + dtoc(_yDtllog)+" - "+_yHrllog)  		Size 150,20


//@ 050,065 Get _Data3                          	Size 050,50
@ 260,20  BmpButton Type 01 Action _AtuPedFat()
@ 260,90  BmpButton Type 02 Action Close(oDialogo2)

Activate Dialog oDialogo2 CENTERED

Return

// Funcao para Atualizao dos dados do setor comercial
// Aqui libera o Pedido para o setor de Logistica

User function _AtuPedCom()


close(oDialogo)  // Fecha janela de digitao do comercial

// Realiza Analise de Credito

u__mAvCred()

// Alterado By Wlad
// Sempre liberar o crdito
_mCredito := .T.

If !_mCredito
	MsgBox("Cliente no Possui Crdito Suficiente, Favor contatar o Setor Financeiro",,"Anlise de Crdito","ALERT")
	U_WFFATA02("PEDIDO RECUSADO")
	Return(Nil)
Endif


// Crtica questionando se libera para Logistica,ou se devolve para o comercial

_LokC := .f. // Flag Libera para Comercial
_lokL := .f. // Flag Liberao  Logistica

// Verifica se retorna o pedido para Logistica
If SC6->C6_YSTATUS == 'L'
	_lokC:=MSGBOX("Retorna Pedido para Comercial?","Liberao do Pedido","YESNO")
Else
	_lokL:=MSGBOX("Libera Pedido para Logstica?","Liberao do Pedido","YESNO")
Endif

// Atualiza SC5
dbSelectArea('SC5')
If RecLock("SC5",.f.)
	Replace C5_TPFRETE WITH IIF(substr(_mTpfrete,1,1) == "1","C",IIF(substr(_mTpfrete,1,1) == "2","F","P"))
	Replace C5_YVFRETE WITH _myVfrete
	Replace C5_YMENLOG WITH _myMenlog
	mSunlock()
Endif

// Retorna para SC6 e atualiza
dbSelectArea("SC6")
if Reclock("SC6",.f.)
	Replace C6_SUGENTR  WITH _mData
	Replace C6_QTDLIB   WITH _mQtdLib
	
	If _lokL
		Replace C6_YSTATUS WITH "L"   // libera para logistica
		Replace C6_YDTLCOM WITH dDatabase
		Replace C6_YHRLCOM WITH TIME()
	ElseIf _lokC
		Replace C6_YSTATUS WITH "C"   // Devolve para o comercial
		Replace C6_YDTLCOM WITH dDatabase
		Replace C6_YHRLCOM WITH TIME()
	Endif
	mSunlock()
Endif

If _lokL
	// Chama o programa para acessar o WORKFLOW e enviar email
	U_WFFATA01("1-COMERCIAL")
	U_WFFATA02("PEDIDO LIBERADO")
Endif


Return


// Funcao para utilizao do setor de Logistica

// Funcao para liberar Pedido ao setor Faturamento
User function _AtuPedLog()

close(oDialogo1)  // Fecha janela de digitao do comercial

_LokL := .F. // Flag Liberao  Logistica
_lokF := .F. // Flag Liberao  Faturamento

// Verifica se retorna o pedido para Logistica ou libera Para Faturamento
If SC6->C6_YSTATUS == 'F'
	_lokL:=MSGBOX("Retorna Pedido para Logistica?","Liberacao do Pedido","YESNO")
Else
	_lokF:=MSGBOX("Libera Pedido para Faturamento?","Liberacao do Pedido","YESNO")
Endif

//Questiona se hover liberao, a quantidade no pode ser zerada
If _lokF .AND. _mQtdLib == 0
	MSGBOX("Atencao! Pedido nao pode ser liberado para Faturamento. Quantidade Zerada!","Quantidade Informada","YESNO")
Endif

// Verifica se retorna pedido para logistica
If _lokL
	// Retorna para SC6 e atualiza
	dbSelectArea("SC6")
	if Reclock("SC6",.f.)
		Replace C6_ENTREG   WITH _mData
		Replace C6_QTDLIB   WITH _mQtdLib
		Replace C6_YSTATUS WITH "L"   		// libera para logistica
		Replace C6_YDTLLOG WITH dDatabase   // atualiza Data de retorno do pedido
		Replace C6_YHRLLOG WITH TIME()		// atualiza Data de retorno do pedido
		Replace C6_YALTERA WITH .T.      // altera o status do pedido de venda para " ALterado"
		
		// Replace C6_YC6OBS  WITH _yC6obs
		mSunlock()
		
	Endif
	Return(Nil)
Endif

dbSelectArea("SC5")
if Reclock("SC5",.f.)
	Replace C5_VEICULO 	WITH _mVeiculo
	Replace C5_PLACA 	WITH _mPlaca
	Replace C5_UFPLACA 	WITH _mUfPlaca
	Replace C5_YCODMOT 	WITH _mMotoris
	Replace C5_TRANSP   WITH _mTransp
	mSunlock()
Endif

// RETORNA AREA SC6 e atualiza Status
dbSelectArea('SC6')
If RecLock("SC6",.f.)
	Replace C6_ENTREG 	WITH _mData
	Replace C6_QTDLIB   WITH _mQtdLib
	Replace C6_YVEICUL  WITH _mVeiculo
	Replace C6_YPLACA 	WITH _mPlaca
	Replace C6_YCODMOT  WITH _mMotoris
	Replace C6_YNOMMOT  WITH _mNomMot
	Replace C6_YDTLLOG  WITH dDatabase
	Replace C6_YHRLLOG  WITH TIME()
	Replace C6_YC6OBS WITH _yC6obs
	
	If _lokF
		dbSelectArea("SC6")
		_cRecno := Recno()
		_mNum   := SC6->C6_NUM
		_mItem  := SC6->C6_ITEM
		cQuery := "UPDATE SC6010 SET C6_YSTATUS = 'F', C6_YDTLLOG = '"+dtos(ddatabase)+"' "
		cQuery += "WHERE C6_FILIAL = '"+xFilial()+"' AND D_E_L_E_T_ = ''"
		cQuery += "AND C6_NUM = '"+_mNum+"' AND C6_ITEM = '"+_mItem+"' "
		TCSQLExec(cQuery)
		
		U_WFFATA01("2-LOGISTICA")  // Envia email para faturamento CC
		U_WFFATA03("2-LOGISTICA")  // Envia relatrio Controle Comercial
		dbSelectArea("SC6")
		go _cRecno
	Endif
	mSunlock()
Endif


Return

// Funcao para utilizao do setor de Faturamento

// Funcao para liberar Pedido ao setor Faturamento

User function _AtuPedFat()

// Verifica se preencheu o Peso Liquido / Bruto
If _mPesoL == 0 .or. _mPbruto == 0
	MSGBOX("Ateno! Peso Liquido ou Peso Bruto Zerados. Informe o Peso.","Preenchimento de Peso","ALERT")
	Return(Nil)
Endif

If _mPesoL <> _mPbruto
	MSGBOX("Ateno! Peso Bruto deve ser Igual ao Peso Liquido. Favor corrigir.","Preenchimento de Peso","ALERT")
	Return(Nil)
Endif


close(oDialogo2)  // Fecha janela de digitao do comercial

// Crtica questionando se libera para Logistica,ou se devolve para o comercial

_LokC := .f. // Flag Libera para Comercial
_lokL := .f. // Flag Liberao  Logistica

dbSelectArea("SC5")
if Reclock("SC5",.f.)
	//	Replace C5_TRANSP  WITH _mTransp
	//	Replace C5_TPFRETE WITH _mTpfrete
	Replace C5_PESOL   WITH _mPesoL
	Replace C5_PBRUTO  WITH _mPbruto
	Replace C5_VOLUME1 WITH _mVolume1
	Replace C5_ESPECI1 WITH _mEspeci1
	Replace C5_TPCARGA WITH _mTpCarga
	Replace C5_MENNOT1 WITH _mMenssag1
	Replace C5_MENNOT2 WITH _mMenssag2
	Replace C5_MENNOT3 WITH _mMenssag3
	Replace C5_MENNOT4 WITH _mMenssag4
	Replace C5_MENNOT5 WITH _mMenssag5
	Replace C5_MENNOT6 WITH _mMenssag6
	Replace C5_MENNOT7 WITH _mMenssag7
	msUnlock()
Endif

// RETORNA AREA SC6 e atualiza Status
dbSelectArea('SC6')


If RecLock("SC6",.f.)
	//   C6_YSTATUS := 'F'
	
	//C6_QTDLIB := _mPesoL
	Replace C6_QTDLIB With _mPesoL
	msUnlock()
	
	
EndIf
// Entra na liberao de pedidos
_lokF:=MSGBOX("Libera Pedido de Vendas?","Liberao do Pedido","YESNO")

If _lokF
	MATA440()
Endif


Return

// Funcao para Verificar se peso informado > peso liberado

User function _Validpeso(_mxPeso)

// Valida o Peso utilizando a margem de 10% para mais ou para menos
If (_mxPeso > _mQTdlib*1.1)
	MSGBOX("Peso Informado MAIOR que a margem de segurana. Verifique!","Peso Informado","ALERT")
	_mxPeso :=0
	_mPesoL		:= 0
Endif

If (_mxPeso < _mQTdlib*0.9)
	MSGBOX("Peso Informado MENOR que a margem de segurana. Verifique!","Peso Informado","ALERT")
	_mxPeso :=0
	_mPesoL		:= 0
Endif

If _mxPeso > SC6->C6_QTDVEN
	_lokP:=MSGBOX("Peso Informado MAIOR que a quantidade vendida. Deseja Igualar a Quantidade Vendida com a Quantidade Pesada?","Peso Informado","YESNO")
	If _lOkP
		dbSelectArea("SC6")
		If RecLock("SC6",.F.)
			C6_QTDVEN := _mxPeso
			C6_VALOR  := _mxPeso*C6_PRCVEN
			//         C6_QTDLIB := _mxPeso wec
			msUnlock()
		Endif
	Endif
EndIf

_mPbruto := _mPesoL

u_rfata05(_mPesoL)

// Mostra Valores de calculo do pedido para auxiliar o faturamento

@ 010,330 say space(10)
@ 020,330 say space(10)
@ 030,330 say space(10)
@ 040,330 say space(10)
@ 050,330 say space(10)
@ 060,330 say space(10)

@ 010,330 say Transform(_nValMerc,'@E 99,999.99') of odialogo2 PIXEL
@ 020,330 say Transform(_nBaseIcm,'@E 99,999.99') of odialogo2 PIXEL
@ 030,330 say Transform(_nValIcm,'@E 99,999.99')  of odialogo2 PIXEL
@ 040,330 say Transform(_nValSol,'@E 99,999.99')  of odialogo2 PIXEL
@ 050,330 say Transform(_nBaseIcm+_nValsol,'@E 99,999.99') of odialogo2 PIXEL
@ 060,330 say Transform(_nPrVen,'@E 99,999.99')  of odialogo2 PIXEL


GETDREFRESH(oDialogo2)

Return(_mxPeso)

// Funcao para Validar se qtd liberada > saldo de pedido

User Function _mVldLib(_mxPeso)

If _mQtdLib > SC6->C6_QTDVEN-SC6->C6_QTDENT
	MSGBOX("Peso Liberado MAIOR que Saldo de Pedido. Verifique!","Peso Informado","ALERT")
	_mxPeso :=0
Endif


Return(_mxPeso)



// Funcao para Montar Legendas coloridas

User function Legenda()

brwlegenda('Status Pedidos de Venda','Legenda',aLegenda)
return


// Funcao para mostrar o nome da transportadora

User Function _Nometran

_mNomtrans := Posicione("SA4",1,xFilial("SA4")+_mTransp,"A4_NOME")
@ 090,130 Say OemToAnsi(_mNomtrans)      						//Size 050,500


Return

// Funcao para Avaliar o Credito do Cliente

User Function _mAvCred()

//Ŀ
//Realiza a Avaliacao de Credito                                          
//

/*

// tentativa 1 wlad
_VlrTitAbe := SldCliente(SC9->C9_CLIENTE + SC9->C9_LOJA, Nil, Nil, .F.)
_VlrTitAtr := CrdXTitAtr(SC9->C9_CLIENTE + SC9->C9_LOJA, Nil, Nil, .F.)
_ValItPed  := SC6->C6_QTDLIB*SC6->C6_PRCVEN
_mCredito := .t.
LJMsgRun("Aguarde... Efetuando Analise de Crdito.",,{|| _mCredito := FatCredTools(SC6->C6_CLI, SC6->C6_LOJA, _ValItPed, _VlrTitAbe, _VlrTitAtr)})

//
ParamIxb[1]=Cdigo do cliente -
ParamIxb[2]=Cdigo da filial -
ParamIxb[3]=Valor da venda -
ParamIxb[4]=Moeda da venda -
ParamIxb[5]=Considera acumulados de Pedido de Venda do SA1 -
ParamIxb[6]=Tipo de crdito (L - Cdigo cliente + Filial; C - cdigo do cliente) -
ParamIxb[7]=Indica se o credito ser liberado ( Lgico ) -
ParamIxb[8]=Indica o cdigo de bloqueio do credito ( Caracter )
*/

//_mValAv		:= SC6->C6_QTDLIB*SC6->C6_PRCVEN
//_mCredito 	:= MaAvalCred(SC6->C6_CLI,SC6->C6_LOJA,_mValAv,SC5->C5_MOEDA,.T.,,@cBlqCred)

// Query para Calcular o valor de Titulos em Atraso do Cliente
cQuery := ""
cQuery += "SELECT SUM(E1_SALDO) AS MSALDO "
cQuery += "FROM SE1010 WHERE D_E_L_E_T_ = '' AND E1_CLIENTE = '"+SC6->C6_CLI+"' AND E1_LOJA = '"+SC6->C6_LOJA+"' "
cQuery += "AND E1_SALDO > 0 AND E1_VENCREA < '20201231' "
TCQUERY cQuery NEW ALIAS 'cAliasSLD'
//cQuery := ChangeQuery(cQuery)
//DbUseArea(.T., "TOPCONN", TCGenQry(,,cQuery), cAliasSLD, .F., .T.)

_VlrTitAbe := MSALDO   // Saldo de Titulos em Aberto
USE

dbSeLectArea("SA1")
dbSetOrder(1)
dbSeek(xFilial("SA1")+SC6->C6_CLI + SC6->C6_LOJA)

_VlrLimCred:= SA1->A1_LC                                                        // Limite de Credito
_ValItPed  := SC6->C6_QTDLIB*SC6->C6_PRCVEN 									// Valor do pedido


If _VlrLimCred - _VlrTitAbe - _ValItPed < 0
	_mCredito := .f.
Endif

dbSelectArea("SC6")

Return(_mCredito)

// Funcao para Validar SX1 - adiciona perguntas se no estiver cadastrada

/*static function ValidaPerguntas()
private aRegs := {}
private i,j

dbselectarea('SX1')
dbsetorder(1)

// Grupo/Ordem/Pergunta/Variavel/Tipo/Tamanho/Decimal/Presel/GSC/Valid/Var01/Def01/Cnt01/Var02/Def02/Cnt02/Var03/Def03/Cnt03/Var04/Def04/Cnt04/Var05/Def05/Cnt05
aadd(aRegs,{cPerg,'01','Data inicial ?'	,'Data inicial ?','Data inicial ?','MV_CH1','D',08,00,0,'G','','MV_PAR01',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'02','Data final ?'	,'Data final ?'	 ,'Data final ?'  ,'MV_CH2','D',08,00,0,'G','','MV_PAR02',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'03','Do Cliente ?'	,'Do cliente ?'	 ,'Do Cliente ?'  ,'MV_CH3','C',06,00,0,'G','','MV_PAR03',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'04','Ate Cliente?'	,'Ate Cliente?'	 ,'Ate Cliente?'  ,'MV_CH4','C',02,00,0,'G','','MV_PAR04',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'05','Da Loja    ?'	,'Da Loja    ?'	 ,'Da Loja    ?'  ,'MV_CH5','C',06,00,0,'G','','MV_PAR05',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'06','Ate Loja   ?'	,'Ate Loja   ?'	 ,'Ate Loja   ?'  ,'MV_CH6','C',02,00,0,'G','','MV_PAR06',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'07','Da Obra    ?'	,'Da Obra    ?'	 ,'Da Obra    ?'  ,'MV_CH7','C',09,00,0,'G','','MV_PAR07',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'08','Ate a Obra ?'	,'Ate a Obra ?'	 ,'Ate a Obra ?'  ,'MV_CH8','C',09,00,0,'G','','MV_PAR08',"","","","","","","","","","","","","",""})
aadd(aRegs,{cPerg,'09','Considera Residuos ?'	,'Considera Residuos ?'	 ,'Considera Residuos ?'  ,'MV_CH9','N',01,00,0,'C','','MV_PAR09',"Sim","Sim","Sim","","","No","No","No","","","","","",""})
aadd(aRegs,{cPerg,'10','Considera Faturados?'	,'Considera Faturados?'	 ,'Considera Faturados?'  ,'MV_CHA','N',01,00,0,'C','','MV_PAR10',"Sim","Sim","Sim","","","No","No","No","","","","","",""})

for i:=1 to len(aRegs)
if !dbseek(cPerg+aRegs[i,2])
recLock('SX1',.T.)

for j:=1 to fcount()
if j <= len(aRegs[i])
FieldPut(j,aRegs[i,j])
endif
next

msunlock()
endif
next
return */
